src/Entity/User.php
<?php

namespace App\Entity;

use App\Repository\UserRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Security\Core\User\UserInterface;
use Symfony\Component\Validator\Constraints\Length;
use Symfony\Component\Validator\Constraints\NotBlank;
use Symfony\Component\Validator\Constraints\NotNull;

#[ORM\Table("users")]
#[ORM\Entity(repositoryClass: UserRepository::class)]
class User implements UserInterface
{

    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(type: 'string')]
    #[Length(
        min: 3,
        max: 50,
        minMessage: "Le prénom saisir est trop petit",
        maxMessage: "Le prénom saisir est trop grand"
    )]
    #[NotNull(
        message: "Le champ ne peux pas être vide"
    )]
    #[NotBlank(
        message: "Le champ ne peux être vide"
    )]
    private ?string $prenom = null;

    #[ORM\Column(type: 'string')]
    #[Length(
        min: 3,
        max: 50,
        minMessage: "Le nom saisir est trop petit",
        maxMessage: "Le nom saisir est trop grand"
    )]
    #[NotNull(
        message: "Le champ ne peut pas être vide"
    )]
    #[NotBlank(
        message: "Le champ ne peut pas être vide"
    )]
    private ?string $nom = null;

    #[ORM\Column(type: 'integer', unique: true)]
    #[Length(
        min: 4,
        max: 4,
        minMessage: "Le code pin est trop petit",
        maxMessage: "Le code pin est trop grand"
    )]
    #[NotNull(
        message: "Le champ ne peut pas être vide"
    )]
    #[NotBlank(
        message: "Le champ ne peut pas être vide"
    )]
    private ?int $pin = null;

    #[ORM\Column(type: 'json')]
    private array $roles = [];

    #[ORM\OneToMany(mappedBy: 'employe', targetEntity: Intervention::class)]
    private Collection $interventions;

    public function __construct()
    {
        $this->interventions = new ArrayCollection();
    }

    public function getId(): int
    {
        return $this->id;
    }

    public function getPrenom(): ?string
    {
        return $this->prenom;
    }

    public function setPrenom(string $prenom): self
    {
        $this->prenom = $prenom;

        return $this;
    }

    public function getNom(): ?string
    {
        return $this->nom;
    }

    public function setNom(string $nom): self
    {
        $this->nom = $nom;

        return $this;
    }

    public function getPin(): ?int
    {
        return $this->pin;
    }

    public function setPin(int $pin): self
    {
        $this->pin = $pin;
        return $this;
    }

    public function getRoles(): array
    {
        $roles = $this->roles;

        $roles[] = 'ROLE_EMPLOYEE';

        return array_unique($roles);
    }

    public function setRoles(array $roles): self
    {
        $this->roles = $roles;

        return $this;
    }

    public function getUsername()
    {
        return (string) $this->pin;
    }

    public function eraseCredentials()
    {
    }

    // On se connecte via code pin donc pas besoin
    public function getPassword()
    {
        return null;
    }

    // On se connecte via code pin donc pas besoin
    public function getSalt()
    {
        return null;
    }

    public function getUserIdentifier(): string
    {
        return (string) $this->pin;
    }

    /**
     * @return Collection<int, Intervention>
     */
    public function getInterventions(): Collection
    {
        return $this->interventions;
    }

    public function addIntervention(Intervention $intervention): self
    {
        if (!$this->interventions->contains($intervention)) {
            $this->interventions->add($intervention);
            $intervention->setEmploye($this);
        }

        return $this;
    }

    public function removeIntervention(Intervention $intervention): self
    {
        if ($this->interventions->removeElement($intervention)) {
            // set the owning side to null (unless already changed)
            if ($intervention->getEmploye() === $this) {
                $intervention->setEmploye(null);
            }
        }

        return $this;
    }

    public function getNomComplet(): ?string
    {
        return $this->nom . ' ' . $this->prenom;
    }
}

src/Controller/SecurityController.php
<?php

namespace App\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\Security\Http\Authentication\AuthenticationUtils;

final class SecurityController extends AbstractController
{
    #[Route(path: '/connexion', name: 'app_login')]
    public function login(AuthenticationUtils $authenticationUtils): Response
    {
        if ($this->getUser()) {
            return $this->redirectToRoute('app_home');
        }
        $error = $authenticationUtils->getLastAuthenticationError();
        $lastUsername = $authenticationUtils->getLastUsername();

        return $this->render('security/login.html.twig', ['last_username' => $lastUsername, 'error' => $error]);
    }

    #[Route(path: '/deconnecter', name: 'app_logout')]
    public function logout(): void
    {
        throw new \LogicException('This method can be blank - it will be intercepted by the logout key on your firewall.');
    }
}

templates/security/login.html.twig
<!DOCTYPE html>
<html>
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <meta name="apple-mobile-web-app-capable" content="yes" />
        <title>{% block title %}Page de connexion{% endblock %}</title>
        <link rel="icon" href="data:image/svg+xml,<svg xmlns=%22http://www.w3.org/2000/svg%22 viewBox=%220 0 128 128%22><text y=%221.2em%22 font-size=%2296%22>⚫️</text></svg>">
        {% block stylesheets %}
            {{ encore_entry_link_tags('app') }}
            <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.2.0/css/all.min.css" integrity="sha512-xh6O/CkQoPOWDdYTDqeRdPCVd1SpvCA9XXcUnZS2FmJNp1coAFzvtCN9BmamE+4aHK8yyUHUSCcJHgXloTyT2A==" crossorigin="anonymous" referrerpolicy="no-referrer" />
            <style>
                html,
                body {
                height: 100%;
                }

                body {
                display: flex;
                align-items: center;
                padding-top: 40px;
                padding-bottom: 40px;
                background-color: #f5f5f5;
                }

                .form-signin {
                max-width: 330px;
                padding: 15px;
                }

                .form-signin .form-floating:focus-within {
                z-index: 2;
                }

                .form-signin input[type="email"] {
                margin-bottom: -1px;
                border-bottom-right-radius: 0;
                border-bottom-left-radius: 0;
                }

                .form-signin input[type="password"] {
                margin-bottom: 10px;
                border-top-left-radius: 0;
                border-top-right-radius: 0;
                }

            </style>
        {% endblock %}

        {% block javascripts %}
            {{ encore_entry_script_tags('app') }}
        {% endblock %}
    </head>
    <body class="text-center">
        <div class="form-signin w-100 m-auto">
            <form method="post">
            {% if error %}
                <div class="alert alert-danger">{{ error.messageKey|trans(error.messageData, 'security') }}</div>
            {% endif %}

            {% if app.user %}
                <div class="mb-3">
                    Vous êtes déjà connecté {{ app.user.userIdentifier }}, <a href="{{ path('app_logout') }}">Se déconnecter</a>
                </div>
            {% endif %}

            <h1 class="h3 mb-3 font-weight-normal">Veuillez-vous connecter</h1>
            <label for="inputPin" class="mb-4">Code PIN</label>
            <input type="number" value="{{ last_username }}" name="pin" id="inputPin" class="form-control mb-4" autocomplete="username" required autofocus>
            <input type="hidden" name="_csrf_token"
                value="{{ csrf_token('authenticate') }}"
            >

            <button class="w-100 btn btn-lg btn-primary" type="submit">
                Se connecter
            </button>
        </form>
        </div>

    </body>
</html>